/*
 * statemachine.cpp
 *
 *  Created on: 21 Sep 2023
 *      Author: Dario
 */

#include <sta/tacos/statemachine.hpp>

#include <sta/debug/debug.hpp>


namespace sta
{
	namespace tacos
	{
		Statemachine::Statemachine()
			: currentState_{STA_TACOS_INITIAL_STATE}, lockoutTimer_{[](void *){}, NULL}, failsafeTimer_{[](void *){}, NULL}
		{
			STA_ASSERT(STA_TACOS_INITIAL_STATE < STA_TACOS_NUM_STATES);
		}

		void Statemachine::init()
		{
			STA_DEBUG_PRINTLN("INITIALIZING STATEMACHINE");

			/*
			lockoutTimer_.setCallback([](void *) { STA_DEBUG_PRINTLN("Lockout timer triggered!"); }, NULL);
			lockoutTimer_.start(1000);

			failsafeTimer_.setCallback([](void *) { STA_DEBUG_PRINTLN("Failsafe timer triggered!"); }, NULL);
			failsafeTimer_.start(2000);
			*/
		}

		void Statemachine::func()
		{
			// STA_DEBUG_PRINTLN("LOOPY LOOP IN STATEMACHINE");

			STA_DEBUG_PRINT("Failsafe timer is running: ");
			STA_DEBUG_PRINTLN(failsafeTimer_.isRunning());

			osDelay(1000);
		}

		uint16_t Statemachine::getCurrentState() const
		{
			return currentState_;
		}

		Statemachine* Statemachine::_instance = nullptr;

	}  // namespace tacos
}  // namespace sta



